Forgot few S_I* imports.
[p5sagit/p5-mst-13.2.git] / t / io / pipe.t
CommitLineData
378cc40b 1#!./perl
2
79072805 3# $RCSfile: pipe.t,v $$Revision: 4.1 $$Date: 92/08/07 18:27:31 $
378cc40b 4
774d564b 5BEGIN {
6 chdir 't' if -d 't';
7 @INC = '../lib';
8 require Config; import Config;
9 unless ($Config{'d_fork'}) {
10 print "1..0\n";
11 exit 0;
12 }
13}
14
378cc40b 15$| = 1;
1d3434b8 16print "1..12\n";
378cc40b 17
092bebab 18# External program 'tr' assumed.
c07a80fd 19open(PIPE, "|-") || (exec 'tr', 'YX', 'ko');
20print PIPE "Xk 1\n";
21print PIPE "oY 2\n";
378cc40b 22close PIPE;
23
092bebab 24if ($^O eq 'vmesa') {
25 # Doesn't work, yet.
26 print "ok 3\n";
27 print "ok 4\n";
28 print "ok 5\n";
29 print "ok 6\n";
30} else {
31 if (open(PIPE, "-|")) {
32 while(<PIPE>) {
33 s/^not //;
34 print;
35 }
36 close PIPE; # avoid zombies which disrupt test 12
37 }
38 else {
39 # External program 'echo' assumed.
40 print STDOUT "not ok 3\n";
41 exec 'echo', 'not ok 4';
378cc40b 42 }
ac58e20f 43
092bebab 44 pipe(READER,WRITER) || die "Can't open pipe";
ac58e20f 45
092bebab 46 if ($pid = fork) {
47 close WRITER;
48 while(<READER>) {
49 s/^not //;
50 y/A-Z/a-z/;
51 print;
52 }
53 close READER; # avoid zombies which disrupt test 12
54 }
55 else {
56 die "Couldn't fork" unless defined $pid;
57 close READER;
58 print WRITER "not ok 5\n";
59 open(STDOUT,">&WRITER") || die "Can't dup WRITER to STDOUT";
60 close WRITER;
61 # External program 'echo' assumed.
62 exec 'echo', 'not ok 6';
ac58e20f 63 }
ac58e20f 64}
65
ac58e20f 66pipe(READER,WRITER) || die "Can't open pipe";
67close READER;
68
69$SIG{'PIPE'} = 'broken_pipe';
70
71sub broken_pipe {
1d2dff63 72 $SIG{'PIPE'} = 'IGNORE'; # loop preventer
ac58e20f 73 print "ok 7\n";
74}
75
76print WRITER "not ok 7\n";
77close WRITER;
3d57aefb 78sleep 1;
ac58e20f 79print "ok 8\n";
03136e13 80
81# VMS doesn't like spawning subprocesses that are still connected to
1d3434b8 82# STDOUT. Someone should modify tests #9 to #12 to work with VMS.
03136e13 83
84if ($^O eq 'VMS') {
85 print "ok 9\n";
86 print "ok 10\n";
1d3434b8 87 print "ok 11\n";
88 print "ok 12\n";
03136e13 89 exit;
90}
91
6ee623d5 92if ($Config{d_sfio} || $^O eq machten || $^O eq beos) {
03136e13 93 # Sfio doesn't report failure when closing a broken pipe
fc261528 94 # that has pending output. Go figure. MachTen doesn't either,
95 # but won't write to broken pipes, so nothing's pending at close.
6ee623d5 96 # BeOS will not write to broken pipes, either.
03136e13 97 print "ok 9\n";
98}
99else {
100 local $SIG{PIPE} = 'IGNORE';
101 open NIL, '|true' or die "open failed: $!";
102 sleep 2;
103 print NIL 'foo' or die "print failed: $!";
104 if (close NIL) {
105 print "not ok 9\n";
106 }
107 else {
108 print "ok 9\n";
109 }
110}
111
092bebab 112if ($^O eq 'vmesa') {
113 # These don't work, yet.
114 print "ok 10\n";
115 print "ok 11\n";
116 print "ok 12\n";
117 exit;
118}
119
03136e13 120# check that errno gets forced to 0 if the piped program exited non-zero
121open NIL, '|exit 23;' or die "fork failed: $!";
122$! = 1;
123if (close NIL) {
124 print "not ok 10\n# successful close\n";
125}
126elsif ($! != 0) {
127 print "not ok 10\n# errno $!\n";
128}
129elsif ($? == 0) {
130 print "not ok 10\n# status 0\n";
131}
132else {
133 print "ok 10\n";
134}
1d3434b8 135
136# check that status for the correct process is collected
062dddbe 137wait; # Collect from $pid
1d3434b8 138my $zombie = fork or exit 37;
139my $pipe = open *FH, "sleep 2;exit 13|" or die "Open: $!\n";
140$SIG{ALRM} = sub { return };
141alarm(1);
142my $close = close FH;
143if ($? == 13*256 && ! length $close && ! $!) {
144 print "ok 11\n";
145} else {
146 print "not ok 11\n# close $close\$?=$? \$!=", $!+0, ":$!\n";
147};
148my $wait = wait;
149if ($? == 37*256 && $wait == $zombie && ! $!) {
150 print "ok 12\n";
151} else {
062dddbe 152 print "not ok 12\n# pid=$wait first=$pid pipe=$pipe zombie=$zombie me=$$ \$?=$? \$!=", $!+0, ":$!\n";
1d3434b8 153}